#!/usr/bin/python2.7
import sys, os, string
from collections import defaultdict

if __name__ == "__main__":
    f = open(sys.argv[1])

    M = defaultdict(list)

    for orig_name, b, output_section in [x.split() for x in f]:
        orig_name = orig_name.strip()
        output_section = output_section.strip()
        
        if output_section == '-':
            continue

        stripped = orig_name
        if orig_name[0] == '_':
            stripped = orig_name[1:]
        
        input_section = '.text.' + stripped
        M[output_section].append(input_section)

    f.close()

    # FIXME: *({section}) matches every file
    entry_pattern = "    {overlay_section_name} {{ {sections} ; . = ALIGN(8); }}\n"
    overlay_desc = "/* Autogenerated section list follows */\n"

    always_internal_desc = ' '.join(['*(%s)' % section \
        for section in M['-INTERNAL']])
    del M['-INTERNAL']

    for output_section in M:
        sections = ' '.join(['*(%s)' % section for section in M[output_section]])
        overlay_desc += entry_pattern.format(overlay_section_name=output_section,
                                             sections=sections)

    f = open(sys.argv[2])
    s = f.read()
    f.close()

    with_overlays = string.replace(s, "/*<<<OVERLAY_AUTOGEN_MARKER>>>*/", overlay_desc)
    print string.replace(with_overlays, "/*<<<INTERNAL_AUTOGEN_MARKER>>>*/", always_internal_desc)
